INTRODUCTION
------------
Integrates the Clipboard.js library with Drupal.

REQUIREMENTS
------------
 * clipboard.js library - https://github.com/zenorocha/clipboard.js/archive/master.zip

INSTALLATION
------------

**MANUAL**

Download and extract the clipboard.js plugin, rename extracted folder to
"clipboard.js" and copy it into "web/libraries". The plugin should
now be located at "web/libraries/clipboard.js/dist/clipboard.js".

**INSTALLATION VIA COMPOSER**

It is assumed you are installing Drupal through Composer using the Drupal
Composer facade. See https://www.drupal.org/docs/develop/using-composer/using-composer-to-manage-drupal-site-dependencies#drupal-packagist

The Clipboard.js Drupal module is shipped with a "composer.libraries.json" file
contains information about the clipboard.js library, required by the module itself.

This file should be merged with the project's main composer.json by the aid
of the Composer Merge Plugin plugin available on GitHub. To make use of
from the project directory, open a terminal and run:

```
composer require wikimedia/composer-merge-plugin
```

Then, edit the "composer.json" file of your website and under the "extra"
section add:

```
"merge-plugin": {
    "include": [
        "web/modules/contrib/clipboardjs/composer.libraries.json"
    ]
}
```

(*) note: the `web` represents the folder where drupal lives like: ex.
`docroot`.

From now on, every time the "composer.json" file is updated, it will also
read the content of "composer.libraries.json" file located at
web/modules/contrib/clipboardjs/ and update accordingly.

Remember, you may have other entries in there already. For this to work, you
need to have the 'oomphinc/composer-installers-extender' installer. If you
don't have it, or are not sure, simply run:

```
composer require oomphinc/composer-installers-extender
```

Then, run the following composer command:

```
composer require drupal/clipboardjs
```

This command will add the clipboardjs Drupal module and the clipboard.js JavaScript library to your
project.

**INSTALLATION VIA DRUSH**

A Drush command is provided for easy installation of the clipboard.js library.

```
drush cbd
```

The command will download the library and unpack it in "libraries".

If you are using Composer to manage your site's dependencies,
then the clipboard.js library will automatically be downloaded to `web/libraries/clipboard.js`.

USAGE
-----
The Clipboard.js can be added to any text field by visiting the manage display
page for the entity and choosing Clipboard.js as the field formatter.

Custom form fields can also use clipboard.js using the form api or in a render
array using the theme function to display the element:

    ```PHP
      $form['clipboardjs'] = [
        '#theme' => 'clipboardjs_button',
        '#value' => 'Any copyable value.',
      ];
    ```

or a full example of one of the available templates e.g., clipboardjs_button,
clipboardjs_snippet, clipboardjs_textarea or clipboardjs_textfield:

    ```PHP
    $form['clipboardjs'] = [
      '#type' => 'item',
      '#theme' => 'clipboardjs_textfield',
      '#title' => $this->t('Clipboard.js Textfield'),
      '#value' => 'Any copyable value.',
      '#label' => $this->t('Click to copy'),
      '#alert_style' => 'tooltip', // e.g., 'tooltip', 'alert' or 'none'
      '#alert_text' => $this->t('Copied!'),
    ];
    ```

CREDITS
-------
Drupal 8/9/10 - Development, Maintenance
* Stefan Auditor - [sanduhrs](https://www.drupal.org/u/sanduhrs)

Initial Development
* Norman Kerr - [kenianbei](https://www.drupal.org/u/kenianbei)
